package hu.bme.mit.bookmanager.ui;

import hu.bme.mit.bookmanager.Book;
import hu.bme.mit.bookmanager.BookManager;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class BookDetailView extends ViewPart {
	private Text txtAuthor;
	private Text txtTitle;
	private Text txtPageNum;
	
	private BookManager mgr = BookManager.initialize();
	private int index = 0;
	private Button chkRead;
	private Button nextButton;
	private Button prevButton;
	
	public BookDetailView() {
	}

	@Override
	public void createPartControl(Composite parent) {
		RowLayout rl_parent = new RowLayout(SWT.VERTICAL);
		rl_parent.fill = true;
		parent.setLayout(rl_parent);
		
		Group grpDetails = new Group(parent, SWT.NONE);
		grpDetails.setText("Details");
		grpDetails.setLayout(new GridLayout(2, false));
		
		Label lblAuthor = new Label(grpDetails, SWT.NONE);
		lblAuthor.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblAuthor.setText("Author");
		
		txtAuthor = new Text(grpDetails, SWT.BORDER);
		txtAuthor.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblTitle = new Label(grpDetails, SWT.NONE);
		lblTitle.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTitle.setText("Title");
		
		txtTitle = new Text(grpDetails, SWT.BORDER);
		txtTitle.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblNumberOfPages = new Label(grpDetails, SWT.NONE);
		lblNumberOfPages.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblNumberOfPages.setText("Number of pages");
		
		txtPageNum = new Text(grpDetails, SWT.BORDER);
		txtPageNum.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblIsRead = new Label(grpDetails, SWT.NONE);
		lblIsRead.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblIsRead.setAlignment(SWT.RIGHT);
		lblIsRead.setText("Is read");
		
		chkRead = new Button(grpDetails, SWT.CHECK);
		
		Composite composite = new Composite(parent, SWT.NONE);
		FillLayout fl_composite = new FillLayout(SWT.HORIZONTAL);
		fl_composite.spacing = 5;
		composite.setLayout(fl_composite);
		prevButton = new Button(composite, SWT.NONE);
		prevButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				index --;
				displayModel();
			}
		});
		prevButton.setText("Previous");
		
		nextButton = new Button(composite, SWT.NONE);
		nextButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				index ++;
				displayModel();
			}
		});
		nextButton.setText("Next");
		
		displayModel();
	}

	public void displayModel() {
		Book book = mgr.getAllBooks().get(index);
		
		txtAuthor.setText(book.getAuthor());
		txtTitle.setText(book.getTitle());
		txtPageNum.setText(Integer.toString(book.getPageNum()));
		chkRead.setSelection(book.isRead());
		
		prevButton.setEnabled(index > 0);
		nextButton.setEnabled(index < mgr.getAllBooks().size() - 1);
	}
	
	@Override
	public void setFocus() {
		// TODO Auto-generated method stub

	}
}
