package hu.bme.mit.bookmanager;

public class Book {

	private final String author;
	private final String title;
	private final int pageNum;
	private boolean isRead;
	
	public Book(String author, String title, int pageNum, boolean isRead) {
		super();
		this.author = author;
		this.title = title;
		this.pageNum = pageNum;
		this.isRead = isRead;
	}
	public boolean isRead() {
		return isRead;
	}
	public void setRead(boolean isRead) {
		this.isRead = isRead;
	}
	public String getAuthor() {
		return author;
	}
	public String getTitle() {
		return title;
	}
	public int getPageNum() {
		return pageNum;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((author == null) ? 0 : author.hashCode());
		result = prime * result + (isRead ? 1231 : 1237);
		result = prime * result + pageNum;
		result = prime * result + ((title == null) ? 0 : title.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Book other = (Book) obj;
		if (author == null) {
			if (other.author != null)
				return false;
		} else if (!author.equals(other.author))
			return false;
		if (isRead != other.isRead)
			return false;
		if (pageNum != other.pageNum)
			return false;
		if (title == null) {
			if (other.title != null)
				return false;
		} else if (!title.equals(other.title))
			return false;
		return true;
	}
}
